/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include <stdio.h>
#include <ctype.h>
/* constants for classes */

#define UNDEF	-1  /* 0 is for defined but not decided yet */
#define DEF		0
#define TERM	1
#define NONTERM	2
#define LIT		3  /*!! =? TERM, get rid? */
#define LIST	4
typedef int		Int;			/* 32 bits int */
typedef short	Short;			/* 16 bits int */
typedef char	Byte;			/*  8 bits int */

typedef int			(*PtF)();
typedef int			(**PtPtF)();
typedef union Node	(*(*PtFrN)());
#undef yywrap
#define yywrap() include_yywrap ()

extern char *yytext;
extern int zzlineno, zzleng;
extern FILE *yyin, *yyout;
extern char *lex_last_name;

/* for include files: */

extern int num_yywrap;

/* for SOURCE_FORM */

extern int source_form;

#define FORM_FIXED	1
#define FORM_FREE	2

typedef struct Oldline {
	int old_len;
	char *old_line;
} Oldline;

Oldline *oldline;
struct S_lst {
	int type;
	char *str;
	struct Typ *typ;
	struct Trans *trans;
#ifdef CHECK
	unsigned attr_check: 1;
	unsigned attr_trans: 1;
	unsigned attr_write: 1;
#endif
	union Node *next;
	union Node *Comma;
	union Node *value;
};

#include "Tree_auto.h"

extern Node *tree;

#define NN	(Node*) 0

#define LIST_LOOP(ele,Lst,temp) temp=Lst; (temp!=(Node*)0)? (ele=temp->lst.value,1):0; temp=temp->lst.next
#define LIST_LOOP2(ele,Lst,temp,ele2,Lst2,temp2) temp=Lst,temp2=Lst2; (temp!=(Node*)0)? (ele=temp->lst.value,ele2=temp2->lst.value,1):0; temp=temp->lst.next,temp2=temp2->lst.next
#define LIST_FIRST(ele,Lst)	(ele == Lst->lst.value)
#define LIST_LAST(temp)	(temp->lst.next == NN)
#define LIST_FIRST_ELE(Lst)	Lst->lst.value
#define LIST_ADD(new, val, temp)  new=make(temp->com.type);new->lst.value=val;new->lst.next=temp->lst.next;temp->lst.next=new;new->lst.Comma=&Comma;temp=new
#define LIST_ELEM(temp)	temp->lst.value

#ifdef CHECK
#define NODE_check(node)  (node)->def.attr_check
#define NODE_trans(node)  (node)->def.attr_trans
#define NODE_write(node)  (node)->def.attr_write
#endif
tree_init ();
Node *list_add ();
Node *list_invert ();
Node *make ();
tree_pp ();
tree_free ();
Node *tree_dup ();
tree_eq ();
pass_init_set_to_null ();
#include "Types_auto.h"

#define node_class(type)	tokens[type].class
#define node_symbol(type)	tokens[type].symbol
#define node_Symbol(type)	tokens[type].Symbol
#define node_size(type)		tokens[type].size
#define node_dump(type)		tokens[type].dump
#define node_nodes(type)	tokens[type].nodes

typedef struct Types_list {
    int class;
    char *symbol;
    char *Symbol;
    int size;
    int nodes;
    PtF dump;
} Types_list;

extern Types_list tokens [];
#define PASS_TOTAL	3

#define PASS_DOWN	0
#define PASS_UP		1

#define PASS_CHECK	0
#define PASS_TRANS	1
#define PASS_WRITE	2

extern PtFrN function [PASS_TOTAL] [2] [LAST_TOKEN];
pass_init ();
check_pass_init ();
trans_pass_init ();
write_pass_init ();
typedef struct Stack {
	char **stack;  /* array of arbitrary pointers */
	int top, current, size, len;
} Stack;

#define stack_TOP(s)	(s->stack [s->top - 1])
Stack *stack_malloc ();
stack_push ();
stack_clear ();
char *stack_pop ();
int stack_index ();
typedef struct Interf {
	char *name;
	int nargs;
	char **args;   /* argument 0 is result for a function */
	struct T_Entry **entry;
} Interf;

extern struct T_Entry *interf_old_entry;
Interf *interf_from_sublist ();
interf_begin ();
interf_enddecl ();
interf_check_interf ();
interf_show ();
interf_set_assumed ();
#define syserr(mess) syserr_internal (__FILE__, __LINE__, mess)
#define syserr_term(mess) syserr_internal_term (__FILE__, __LINE__, mess)
#define SYSERR	syserr((char*)0)
#define SYSERR_TERM	syserr_term((char*)0)

#define NIYERR	syserr_internal (__FILE__, __LINE__, "not implemented yet")
#define IMPERR	syserr_internal (__FILE__, __LINE__, "implement")
#define F90NI	fatal ("Fortran 90 feature not implemented")
#define SYNERR	synerr ();

#define ERR_OBSOLESCENT	1
#define ERR_WARNING		2
#define ERR_FATAL		3

extern char serr[];

extern int error_level;
synerr ();
yyerror ();
obsol ();
stand ();
f90ni ();
warning ();
fatalnl ();
fatal ();
terminate ();
terminatenl ();
comerrnl ();
comerr ();
syserr_internal ();
syserr_internal_term ();
error_check ();
error_init ();
char *error_s ();
error_core ();
error_quit ();
#define TAB_GLOBAL	1
#define TAB_LOCAL	2

#define TAB_NAME			1
#define TAB_NODE			2
#define TAB_TYP				3
#define TAB_TYP_ETYPE		4
#define TAB_TYP_SHAPE		5
#define TAB_INTERF			6
#define TAB_COMPILE_TIME	7
#define TAB_LABEL			8

#define HASHSIZE	101

#define TN	(T_Entry*) 0

extern int table_li;

#define for_TABLE_LOOP(entry) for(table_li=0;table_li<HASHSIZE;table_li++)for(entry=table_scope[table_li];entry!=(T_Entry*)0;entry=(entry)->next)
#define for_TABLE_LOOP_glo(entry) for(table_li=0;table_li<HASHSIZE;table_li++)for(entry=table_scope0[table_li];entry!=(T_Entry*)0;entry=(entry)->next)

#define IS_optional(entry)			(entry)->attr_optional
#define SET_optional(entry)			(entry)->attr_optional = 1
#define IS_assumed_shape(entry)		(entry)->attr_assumed_shape
#define SET_assumed_shape(entry)	(entry)->attr_assumed_shape = 1
#define IS_assumed_pass(entry)		(entry)->attr_assumed_pass
#define SET_assumed_pass(entry)		(entry)->attr_assumed_pass = 1
#define IS_array(entry)				(entry)->attr_array
#define SET_array(entry)			(entry)->attr_array = 1
#define IS_compile_time(entry)		(entry)->attr_compile_time
#define SET_compile_time(entry)		(entry)->attr_compile_time  = 1
#define IS_distributed(entry)		(entry)->attr_distributed
#define SET_distributed(entry)		(entry)->attr_distributed = 1
#define IS_intrinsic(entry)			(entry)->attr_intrinsic
#define SET_intrinsic(entry)		(entry)->attr_intrinsic = 1
#define IS_argument(entry)			(entry)->attr_argument
#define SET_argument(entry)			(entry)->attr_argument = 1
#define IS_automatic(entry)			(entry)->attr_automatic
#define SET_automatic(entry)		(entry)->attr_automatic = 1
#define IS_parameter(entry)			(entry)->attr_parameter
#define SET_parameter(entry)		(entry)->attr_parameter = 1
#define IS_function(entry)			(entry)->attr_function
#define SET_function(entry)			(entry)->attr_function = 1
#define IS_subroutine(entry)		(entry)->attr_subroutine
#define SET_subroutine(entry)		(entry)->attr_subroutine = 1
#define IS_elemental(entry)			(entry)->attr_elemental
#define SET_elemental(entry)		(entry)->attr_elemental = 1
#define IS_external(entry)			(entry)->attr_external
#define SET_external(entry)			(entry)->attr_external = 1
#define IS_implicit(entry)			(entry)->attr_implicit
#define SET_implicit(entry)			(entry)->attr_implicit = 1
#define IS_explicit(entry)			(entry)->attr_explicit
#define SET_explicit(entry)			(entry)->attr_explicit = 1
#define IS_defined_proc(entry)		(entry)->attr_defined_proc
#define SET_defined_proc(entry)		(entry)->attr_defined_proc = 1
#define IS_temporary(entry)			(entry)->attr_temporary
#define SET_temporary(entry)		(entry)->attr_temporary = 1
#define IS_alloc_temp(entry)		(entry)->attr_alloc_temp
#define SET_alloc_temp(entry)		(entry)->attr_alloc_temp = 1
#define IS_result(entry)			(entry)->attr_result
#define SET_result(entry)			(entry)->attr_result = 1
#define IS_over(entry)				(entry)->attr_over
#define SET_over(entry)				(entry)->attr_over = 1
#define IS_common(entry)			(entry)->attr_common
#define SET_common(entry)			(entry)->attr_common = 1
#define IS_save(entry)				(entry)->attr_save
#define SET_save(entry)				(entry)->attr_save = 1
#define IS_has_initexpr(entry)		(entry)->attr_has_initexpr
#define SET_has_initexpr(entry)		(entry)->attr_has_initexpr = 1
#define IS_blank_common(entry)		(entry)->attr_blank_common
#define SET_blank_common(entry)		(entry)->attr_blank_common = 1
#define IS_named_common(entry)		(entry)->attr_named_common
#define SET_named_common(entry)		(entry)->attr_named_common = 1
#define IS_no_checking(entry)		(entry)->attr_no_checking
#define SET_no_checking(entry)		(entry)->attr_no_checking = 1
#define IS_constant(entry)			(entry)->attr_constant
#define SET_constant(entry)			(entry)->attr_constant = 1
#define IS_label(entry)				(entry)->attr_label
#define SET_label(entry)			(entry)->attr_label = 1
#define IS_label_def(entry)			(entry)->attr_label_def
#define SET_label_def(entry)		(entry)->attr_label_def = 1
#define IS_label_ref(entry)			(entry)->attr_label_ref
#define SET_label_ref(entry)		(entry)->attr_label_ref = 1
#define IS_label_format(entry)		(entry)->attr_label_format
#define SET_label_format(entry)		(entry)->attr_label_format = 1
#define IS_label_io(entry)			(entry)->attr_label_io
#define SET_label_io(entry)			(entry)->attr_label_io = 1
#define IS_label_temp(entry)		(entry)->attr_label_temp
#define SET_label_temp(entry)		(entry)->attr_label_temp = 1
#define IS_namelist(entry)			(entry)->attr_namelist
#define SET_namelist(entry)			(entry)->attr_namelist = 1

#define IS_in_common(entry)			((entry)->attr_blank_common || (entry)->attr_named_common)
#define IS_procedure(entry)			((entry)->attr_subroutine || (entry)->attr_function || (entry)->attr_over)
#define IS_interface(entry)			((entry)->attr_implicit || (entry)->attr_explicit)

#define ENTRY_VALUE(entry)	(entry)->value  /* pointer to expression if named constant */
#define ENTRY_OVER(entry)  (entry)->over
#define ENTRY_SUBLIST(entry) ((entry)->node->com.type!=ENTITY_DECL)?(sprintf(serr,"%s",node_symbol((entry)->node->com.type)),syserr(serr),NN):((!IS_array(entry))?NN:(((entry)->node->EntityDecl.opt7==NN)?NN:(entry)->node->EntityDecl.opt7->opt7.SubscriptList))
#define ENTRY_INITEXPR(entry) (entry)->initexpr

#define ENTRY_UNIT(entry) (Unit*) (entry)->over

typedef struct T_Entry {
	char *name, *orig_name, *tempname;
	struct Typ *typ;
	struct T_Entry *next;
	union Node *node;
	Interf *interf;
	PtF compile_time;
	union Node *value;
	struct Over *over;
	union Node *initexpr;

	unsigned attr_optional: 1;       /* optional */
	unsigned attr_assumed_shape: 1;  /* locally an assumed-shape array */
	unsigned attr_assumed_pass: 1;   /* to function that expects an assumed-shape array */
	unsigned attr_array: 1;          /* declared as array */
	unsigned attr_compile_time: 1;   /* intrinsic function evaluated at compile time */
	unsigned attr_distributed: 1;    /* array is data distributed */
	unsigned attr_intrinsic: 1;      /* intrinsic procedure */
	unsigned attr_argument: 1;       /* argument to the current procedure */
	unsigned attr_automatic: 1;      /* automatic array */
	unsigned attr_parameter: 1;      /* parameter */
	unsigned attr_function: 1;       /* function */
	unsigned attr_subroutine: 1;     /* subroutine */
	unsigned attr_elemental: 1;      /* elemental procedure */
	unsigned attr_external: 1;       /* external procedure */
	unsigned attr_implicit: 1;       /* implicit interface */
	unsigned attr_explicit: 1;       /* explicit interface */
	unsigned attr_defined_proc: 1;   /* defined procedure */
	unsigned attr_temporary: 1;      /* translator generated variable */
	unsigned attr_alloc_temp: 1;     /* temporary that needs to be allocated */
	unsigned attr_result: 1;         /* function result */
	unsigned attr_over: 1;           /* overloaded procedure */
	unsigned attr_common: 1;         /* common */
	unsigned attr_save: 1;           /* save */
	unsigned attr_has_initexpr: 1;   /* declaration has initialization expression */
	unsigned attr_blank_common: 1;   /* variable is in blank common */
	unsigned attr_named_common: 1;   /* variable is in named common */
	unsigned attr_no_checking: 1;    /* no interface checking done for procedure */
	unsigned attr_constant: 1;       /* constant, i.e. constant array, parameter */

	unsigned attr_label_def: 1;      /* label and already defined */
	unsigned attr_label_ref: 1;      /* label and already referenced */
	unsigned attr_label_format: 1;   /* label in a format statement */
	unsigned attr_label_io: 1;       /* label in a I/O statement */
	unsigned attr_label_temp: 1;
	unsigned attr_label: 1;          /* any label */

	unsigned attr_namelist: 1;       /* is namelist */
} T_Entry;

extern T_Entry *table_scope0[], *table_scope[];
table_init ();
T_Entry *lookup_all ();
T_Entry *lookup_loc ();
T_Entry *lookup_glo ();
T_Entry *lookup ();
T_Entry *install_loc ();
T_Entry *install_glo ();
T_Entry *install ();
table_show_terse ();
table_show_entry ();
table_show1 ();
table_show1_global ();
table_show1_local ();
table_end ();
T_Entry *table_entry_cp ();
#define CN	(char*) 0

#define U_MAX(a,b)	(((a)>(b))?a:b)
#define U_MIN(a,b)	(((a)>(b))?b:a)

#define U_DEFINE_STACK(array,Type,size)	\
Type *array;\
int array/**/_top = 0, array/**/_size = 0;\
\
Type U_stack_push_/**/array (element)\
Type element;\
{\
	Type *array/**/_new;\
	int i;\
	if (array/**/_top >= array/**/_size) {\
		array/**/_size = array/**/_size + size;\
		array/**/_new = (Type*) U_malloc (sizeof (Type) * array/**/_size);\
		for (i = 0; i < array/**/_size - size; i++)\
			array/**/_new[i] = array[i];\
		free (array);\
		array = array/**/_new;\
	}\
	array[array/**/_top++] = element;\
	return element;\
}\
Type U_stack_pop_/**/array ()\
{\
	return array[--(array/**/_top)];\
}\
U_stack_clear_/**/array ()\
{\
	U_free (array);\
	array = (Type*) 0;\
	array/**/_top = 0;\
	array/**/_size = 0;\
}

#define UNEW_DEFINE_STACK_TYPE(array,Type,siz,Stack)\
typedef struct Stack {\
	Type *stack;\
	int top, size;\
	PtF push, pop, clear;\
} Stack;\
extern Stack *array;

#define UNEW_DEFINE_STACK(array,Type,siz,Stack)\
Stack *array=(Stack*)0;\
U_stack_pop_/**/array()\
{\
	--array->top;\
}\
U_stack_clear_/**/array()\
{\
	U_free(array->stack);\
	U_free(array);\
	array=(Stack*)0;\
}\
U_stack_push_/**/array(ele)\
Type ele;\
{\
	Stack *new;\
	int i;\
	if(array==(Stack*)0) {\
		array=(Stack*)U_malloc(sizeof(Stack));\
		array->top=array->size=0;\
	}\
	if(array->top>=array->size){\
		new=(Stack*)U_malloc(sizeof(Stack));\
		new->top=array->top;\
		new->size=array->size+siz;\
		array->push=U_stack_push_/**/array;\
		array->pop=U_stack_pop_/**/array;\
		array->clear=U_stack_clear_/**/array;\
		new->stack=(Type*)U_malloc(sizeof(Type)*new->size);\
		for(i=0;i<new->size-siz;i++)\
			new->stack[i]=array->stack[i];\
		U_free(array->stack);\
		U_free(array);\
		array=new;\
	}\
	array->stack[array->top++]=ele;\
}
char *U_strlower ();
char *U_strupper ();
U_no_core_dump ();
U_on_core_dump ();
char *U_str_copy ();
char *U_str_alloc ();
char *U_str_copy_upper ();
U_malloc_stat_init ();
U_malloc_stat ();
char *U_malloc ();
char* U_realloc ();
U_free ();
U_check_begin ();
U_check_end ();
U_StRcMp ();
U_exit ();
U_coredump ();
U_null ();
int U_strlen ();
char *U_strcat ();
extern int flag_nocore;
extern int flag_tableshow;
extern int flag_coredump;
extern int flag_obsolescent;
extern int flag_externals;
extern int flag_externals_user;
extern int flag_standard;
extern int flag_nointerfaces;
extern int flag_e;
extern int flag_pp;
extern int flag_ko;
extern int flag_cubix;
extern int flag_77;

extern int flag_w;

extern char *input_filename; 
extern char *output_filename; 
extern FILE *ofd;
args ();
typedef struct Shape {
	int rank;
	Node **sizes0;
	Node **sizes1;
	Node **sizes2;
	Node **extent;
} Shape;

typedef struct Etype {
	int type;
	int kind;

} Etype;

typedef struct Typ {
	struct Etype *etype;
	struct Shape *shape;
} Typ;

#define TYP_INTEGER		1
#define TYP_REAL		2
#define TYP_COMPLEX		3
#define TYP_CHARACTER	4
#define TYP_LOGICAL		5

#define SN	(Shape*) 0
#define EN	(Etype*) 0

extern Etype *Etype_INTEGER_0;
extern Etype *Etype_REAL_0;
extern Etype *Etype_COMPLEX_0;
extern Etype *Etype_LOGICAL_0;
extern Etype *Etype_CHARACTER_0;

extern Etype *Etype_REAL_1;
extern Etype *Etype_COMPLEX_1;

#define IS_INTEGER(node) (node->com.typ->etype->type==TYP_INTEGER)
#define IS_REAL(node) (node->com.typ->etype->type==TYP_REAL)
#define IS_COMPLEX(node) (node->com.typ->etype->type==TYP_COMPLEX)
#define IS_LOGICAL(node) (node->com.typ->etype->type==TYP_LOGICAL)
#define IS_CHARACTER(node) (node->com.typ->etype->type==TYP_CHARACTER)
etype_init ();
typ_show ();
Etype *etype_malloc_c ();
Etype *etype_malloc ();
Typ *typ_malloc ();
Shape *shape_malloc ();
Node **sizes_malloc ();
Shape *shape_set_sizes_decl ();
Shape *shape_Elemental ();
Shape *shape_Array ();
Node *extent_from_sub ();
Node *extent_from_subexpr ();
typ_set_index ();
Typ *typ_expr ();
typ_decl_var ();
typ_check_subscripts ();
char *etype_name ();
etype_size ();
Node *typ_shape_to_sublist ();
Node *typ_shape_to_sublist_decl ();
Node *typ_len_to_sublist_decl ();
Shape *shape_copy ();
typ_shape_eq ();
Node *typ_shape_size ();
etype_ne ();
#define INSIDE_ARRAY 		1
#define INSIDE_ELEMENTAL	2

extern int e_array_current;
extern int inside_top;
extern int array_num_index;
array_init ();
array_num_index_set ();
Node *array_index ();
array_dos ();
array_loop ();
array_enddos ();
array_end_after_write ();
array_put_assumed_bounds ();
array_is_assumed_shape ();
array_decl ();
array_end ();
write_Subscript ();
write_AssignementStmt ();
write_ArraySection ();
array_end_statement_write ();
temp_end ();
temp_decl();
temp_init ();
Node *temp_make ();
Node *temp_make_len ();
temp_arrays_decl ();
Node *temp_replace ();
#define UNIT_OUT			0
#define UNIT_PROGRAM		1
#define UNIT_FUNCTION		2
#define UNIT_SUBROUTINE		3
#define UNIT_BLOCK_DATA		4
#define UNIT_MODULE			5
#define UNIT_INTERFACE		6

extern int scoping_unit;
order_init ();
PtF order ();
order_enddecl_parse ();
order_enddecl_write ();
proc_end_before_write ();
proc_end_after_write ();
char *name_out ();
char *name_label ();
char *name_label_num ();
name_end ();
write_Name ();
char *desc_name ();
desc_decl ();
desc_init_entry ();
desc_init ();
Node *desc_extent ();
desc_end ();
extern Node *Node_0, *Node_1;
extern Node *Node_SubscriptList_1;

extern Node **aftprog;
extern int aftprog_top;
make_init ();
Node *make_IntegerConstant ();
Node *make_Statement ();
Node *make_Name ();
Node *make_AssignementStmt ();
Node *make_DumExpr_parse ();
Node *make_DumExpr ();
Node *make_DumExpr_1_PIN ();
Node *make_DumExpr_paren ();
Node *make_DumExpr_PIN ();
Node *make_Subscript ();
Node *make_opt7 ();
Node *make_EntityDecl ();
Node *make_ArraySection ();
Node *make_DumStmt ();
Node *make_Code ();
Node *make_List ();
Node *make_CallStmt ();
Node *make_FunctionReference ();
Node *make_DumList ();
Node *make_LogicalConstant ();
Node *make_EntityDecl1 ();
Node *make_EndDoStmt ();
Node *make_Variable ();
Node *make_DoStmt ();
Node *make_ContinueStmt ();
Node *make_ContinueStatement ();
Node *make_GotoStmt ();
Node *make_IfThenStmt ();
Node *make_EndIfStmt ();
Node *make_ElseStmt ();
char *opt_name ();
opt_decl ();
Node *opt_fill_opt ();
opt_end ();
write_FunctionStmt ();
write_SubroutineStmt ();
write_args ();
write_FunctionReference ();
write_CallStmt ();
write_one_dim_gen ();
write_one_dim ();
write_one_dim_no_auto ();
Node *check_pass ();
check ();
intrin_present ();
intrin_rank ();
intrin_size ();
intrin_init ();
extern int flag_express;
extern int para_NN;
char *para_Pl();
char *para_Pu();
para_decl ();
para_init ();
init ();
#include "outaut.def"

#define onod(node) write_pass (node)
ostart ();
oend ();
odon ();
oflush ();
eof ();
och ();
ostr();
onam ();
olab ();
oint();
ochb ();
otab();
output_check ();
output_init ();
output_delete_output_file ();
implicit_init ();
implicit_end ();
Etype *implicit_get ();
implicit_set ();
implicit_set_none ();
implicit_enddecl ();
Node *parse_pass ();
parse_args ();
Node *parse_CallStmt ();
Node *parse_ArraySection ();
Node *parse_FunctionReference ();
T_Entry *parse_name ();
Node *parse_ImpliedDoControl ();
Node *parse_Variable ();
Node *parse_NamedConstantDef ();
Node *parse_EntityDecl ();
Node *parse_EntityDecl1 ();
Node *parse_TypeDeclarationStmt ();
Node *parse_SubroutineStmt ();
Node *parse_FunctionStmt ();
Node *parse_AssignementStmt ();
Node *parse_IntrinsicStmt ();
Node *parse_DumExpr ();
expr_is_constant ();
expr_sublist_not_constant ();
Node *parse_Primary ();
auto_enddecl ();
auto_write_decl ();
auto_write_arg ();
char *auto_name ();
auto_decl ();
Node **list_alloc ();
Node *auto_ffree_entry ();
Node *auto_fmalloc_entry ();
auto_init ();
auto_end_write ();
auto_end ();
char *fun_name ();
fun_subscript_output ();
fun_out_of_assig ();
fun_end ();
extern Node *se_AttrSpec_list;
extern int se_AttrSpec_opt;
extern int se_AttrSpec_param;
extern int se_AttrSpec_external;
extern int se_AttrSpec_intrinsic;
extern int se_AttrSpec_save;
extern Etype *se_EtypeSpec;
extern int se_DimensionStmt_in;
extern int se_CommonStmt_in;
extern int se_CommonStmt_blank;
extern Typ *se_Where_typ;

extern int se_in_interface;
clear_se ();
typedef struct Over {
	char *name;
	int nover;
	struct T_Entry **entry;
} Over;

extern int over_in;
over_begin ();
over_end ();
over_show ();
T_Entry *over_replace ();
extern int io_in;
io_err_spec_used ();
io_err_spec_type ();
int io_spec_is ();
Node *check_WriteStmt ();
Node *check_ReadStmt ();
Node *check_PrintStmt ();
Node *check_IoStmt ();
checkx_FormatStmt ();
write_IOkeyword ();
write_WriteStmt ();
write_ReadStmt ();
write_PrintStmt ();
cubix_write_IoStmt ();
cubix_write_ImpliedValueList ();

decl_check_entry ();
decl_initexpr_parse ();
write_TypeDeclarationStmt ();
write_EntityDecl ();
int mac_etype_size ();
char *mac_etype_name ();
mac_set ();
char *mac_name ();
char *mac_lowname ();
int mac_index ();
machine_init ();
char *machine_compiler ();
char *machine_obj_suffix ();
typedef struct ArrCons {
	Node *temp;
	Node *list;
	int isconstant;
} ArrCons;

extern int ac_in;
write_ArrayConstructor ();
Node *parse_ArrayConstructor ();
ac_enddecl_write ();
ac_is_constant ();
write_DumArrCons ();
extern int se_in_where;
Node *check_WhereStmt ();
Node *check_WhereConstructStmt ();
Node *check_ElsewhereStmt ();
Node *check_EndWhereStmt ();
Node *trans_WhereStmt ();
write_WhereStmt ();
write_WhereConstruct ();
Node *parse_ImpliedDo_down ();
write_ImpliedDoControl_head ();
T_Entry *label_install_def ();
T_Entry *label_install_ref ();
T_Entry *label_install_format ();
T_Entry *label_install_io ();
label_end ();
Node *label_make ();
extern Node *program_unit;
Node *block_top ();
block_push ();
Node *block_pop ();
block_add_stmt ();
block_add_sta ();
block_add_stmt_decl ();
block_add_sta_decl ();
block_push_program_unit ();
block_init ();
block_add_stmt_init ();
block_add_sta_init ();
block_add_sta_clear ();
block_write_sta_init ();
Node *parse_SelectCaseStmt ();
Node *parse_CaseStmt ();
Node *parse_EndSelectStmt ();
write_SelectCaseStmt ();
write_CaseStmt ();
write_EndSelectStmt ();
char *path_get_full ();
#define CTOF_PROC_NAME(name)	name/**/_
#define CTOF_STRING(str)		str, strlen (str)
write_pass ();
write_pass_childs ();
write_default ();
write_EndStmt ();
write_ProgramUnit ();
write_ForallStmt ();
write_Statement ();
write_DumList ();
typedef struct Trans {
	int type;
	int nbef, naft;
	Node **sta_bef;
	Node **sta_aft;
} Trans;

#define TRN	(Trans*) 0
Node *trans_pass ();
Trans *trans_add_stmt_bef ();
Trans *trans_add_stmt_aft ();
Trans *trans_add_sta_bef ();
Trans *trans_add_sta_aft ();
Trans *trans_malloc ();
typedef struct Types {
	int memory;
	struct Component **comp;
} Types;
assumed_write_decl ();
#define FORM_FIXED	1
#define FORM_FREE	2

extern int source_form;

extern char *form_old_line;
extern int form_old_len;
form_set ();
form_input ();
ungetline ();
char *getline ();
typedef struct Fvar {
	char *label;
	int size;
	char *var, *str;
} Fvar;
cubix_write_top_sta ();
char *cubix_ioret ();
cubix_decl ();
cubix_end ();
cubix_end_write ();
cubix_checkx_FormatStmt ();
Fvar *cubix_get_fvar ();
cubix_write_Statement ();
char *cubix_type ();
typedef struct Unit {
	Node *unit;
	Node *iostat;
	Node *err;
	Node *file;
	Node *status;
	Node *access;
	Node *form;
	Node *recl;
	Node *blank;
	Node *position;
	Node *action;
	Node *delim;
	Node *pad;

/* additional for READ/WRITE */

	Node *fmt;
	Node *nml;
	Node *rec;
	Node *end;
	Node *advance;
	Node *size;
	Node *eor;
} Unit;
Unit *unit_malloc ();
Node *check_OpenStmt ();
Node *check_CloseStmt ();
write_OpenStmt ();
write_CloseStmt ();
cubix_write_OpenStmt ();
cubix_write_CloseStmt ();
#define PASS_PARSE	1
#define PASS_WRITE	2

extern int current_pass;

extern char *malloc (), *realloc ();
main();
